Package serp.bytecode

# Class LocalTable

java.lang.Object
serp.bytecode.Attributes
serp.bytecode.Attribute
serp.bytecode.LocalTable

All Implemented Interfaces:
  `BCEntity`, `InstructionPtr`, `VisitAcceptor`

Direct Known Subclasses:
  `LocalVariableTable`, `LocalVariableTypeTable`

public abstract class LocalTable extends Attribute implements InstructionPtr
Code blocks compiled from source have local tables mapping locals used in opcodes to their names and descriptions.

Author:
  Abe White

## Method Summary

Modifier and Type
Method
Description
`Local`
`addLocal()`
Add a local to this table.
`Local`
`addLocal(String name, String type)`
Add a local to this table.
`Local`
`addLocal(Local local)`
Import a local from another method/class.
`void`
`clear()`
Clear all locals from this table.
`Code`
`getCode()`
Returns the Code block that owns the Instruction(s) this InstructionPtr points to.
`Local`
`getLocal(int local)`
Return the local with the given locals index, or null if none.
`Local`
`getLocal(String name)`
Return the local with the given name, or null if none.
`Local[]`
`getLocals()`
Return all the locals of this method.
`Local[]`
`getLocals(String name)`
Return all locals with the given name, or empty array if none.
`protected abstract Local`
`newLocal()`
Create a new element of this table.
`protected abstract Local[]`
`newLocalArray(int size)`
Create a new array.
`boolean`
`removeLocal(int local)`
Removes the local with the given locals index from the table.
`boolean`
`removeLocal(String name)`
Removes the local with the given name from this method.
`boolean`
`removeLocal(Local local)`
Removes a local from this method.
`void`
`replaceTarget(Instruction oldTarget, Instruction newTarget)`
Replace the given old, likely invalid, target with a new target.
`void`
`setLocals(Local[] locals)`
Set the locals of this table.
`void`
`updateTargets()`
Use the byte indexes read from the class file to calculate and set references to the target instruction(s) for this ptr.

### Methods inherited from class serp.bytecode.Attribute

`getClassLoader, getName, getNameIndex, getOwner, getPool, getProject, isValid`

### Methods inherited from class serp.bytecode.Attributes

`addAttribute, addAttribute, clearAttributes, getAttribute, getAttributes, getAttributes, removeAttribute, removeAttribute, setAttributes`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface serp.bytecode.visitor.VisitAcceptor

`acceptVisit`

## Method Details

### getLocals

public Local[] getLocals()
Return all the locals of this method.

### getLocal

public Local getLocal(int local)
Return the local with the given locals index, or null if none.

### getLocal

public Local getLocal(String name)
Return the local with the given name, or null if none. If multiple locals have the given name, which is returned is undefined.

### getLocals

public Local[] getLocals(String name)
Return all locals with the given name, or empty array if none.

### setLocals

public void setLocals(Local[] locals)
Set the locals of this table. This method is useful when importing locals from another method.

### addLocal

public Local addLocal(Local local)
Import a local from another method/class. Note that the program counter and length from the given local is copied directly, and thus will be incorrect unless this method is the same as the one the local is copied from, or the pc and length are reset.

### addLocal

public Local addLocal()
Add a local to this table.

### newLocal

protected abstract Local newLocal()
Create a new element of this table.

### newLocalArray

protected abstract Local[] newLocalArray(int size)
Create a new array.

### addLocal

public Local addLocal(String name, String type)
Add a local to this table.

### clear

public void clear()
Clear all locals from this table.

### removeLocal

public boolean removeLocal(int local)
Removes the local with the given locals index from the table.

Returns:
  true if a local was removed, false otherwise

### removeLocal

public boolean removeLocal(String name)
Removes the local with the given name from this method.

Returns:
  true if a local was removed, false otherwise

### removeLocal

public boolean removeLocal(Local local)
Removes a local from this method. After this method, the local will be invalid, and the result of any operations on it is undefined.

Returns:
  true if a local was removed, false otherwise

### updateTargets

public void updateTargets()
Description copied from interface: `InstructionPtr`
Use the byte indexes read from the class file to calculate and set references to the target instruction(s) for this ptr. This method will be called after the byte code has been read in for the first time and before it is written after modification.

Specified by:
  `updateTargets` in interface `InstructionPtr`

### replaceTarget

public void replaceTarget(Instruction oldTarget, Instruction newTarget)
Description copied from interface: `InstructionPtr`
Replace the given old, likely invalid, target with a new target. The new target Instruction is guaranteed to be in the same code block as this InstructionPtr.

Specified by:
  `replaceTarget` in interface `InstructionPtr`

### getCode

public Code getCode()
Description copied from interface: `InstructionPtr`
Returns the Code block that owns the Instruction(s) this InstructionPtr points to.

Specified by:
  `getCode` in interface `InstructionPtr`